(** Tas; voir le TP Heapsort. *)

(** Le type, abstrait, reprsentant les tas. *)
type 'a t

(** Renvoie le nombre d'lments du tas. *)
val length : 'a t -> int

(** [of_array ordre array] cre un tas  partir du tableau [array].
  [ordre a b] doit tre [true] si et seulement si [a] est strictement plus petit que [b]. *)
val of_array : ('a -> 'a -> bool) -> 'a array -> 'a t

(** Renvoie l'lment minimal en temps log(n) o n est le nombre d'lments du tas. *)
val take_min : 'a t -> 'a

(** Insre un lment en temps log(n) o n est le nombre d'lments du tas. *)
val insere : 'a -> 'a t -> unit

(** Trie le tableau donn par l'algorithme heapsort. *)
val sort : ('a -> 'a -> bool) -> 'a array -> 'a array
